//
// © 2014 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//

/* globals Game: true */

Game.SwordTemplate = {
    name: 'sword',
    character: '†',
    foreground: 'white',
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 5;
        } else {
            return 7;
        }
    },
    wieldable: true,
    skillname: 'Sword',
    mixins: [Game.ItemMixins.Equippable]
};

Game.KnifeTemplate = {
        name: 'knife',
        character: '`',
        foreground: 'white',
        damage: function() {
            if (Game.Rules.formUnderlyingSelected() === "2014a") {
                return 3;
            } else {
                return 5;
            }
        },
        wieldable: true,
        skillname: 'Knife',
        mixins: [Game.ItemMixins.Equippable]
    };

Game.MaceTemplate = {
    name: 'mace',
    character: '♣',
    foreground: 'white',
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 3;
        } else {
            return 5;
        }
    },
    wieldable: true,
    skillname: 'Club',
    mixins: [Game.ItemMixins.Equippable]
};


Game.LeatherArmourTemplate = {
    name: 'leather armour',
    character: 'Ω',
    foreground: 'white',
    armour: {leftLeg: 1, rightLeg: 1, abdomen:1, chest:1, swordArm:1, shieldArm:1, head:1},
    wearable: true,
    mixins: [Game.ItemMixins.Equippable]
};

Game.ChainArmourTemplate = {
    name: 'chain armour',
    character: 'Ὠ',
    foreground: 'white',
    armour: {leftLeg: 3, rightLeg: 3, abdomen:3, chest:3, swordArm:3, shieldArm:3, head:3},
    wearable: true,
    encumbrance: 3,
    mixins: [Game.ItemMixins.Equippable]
};

Game.SuperiorChainArmourTemplate = {
    name: 'superior chain armour',
    character: 'Ὧ',
    armour: {leftLeg: 4, rightLeg: 4, abdomen:4, chest:4, swordArm:4, shieldArm:4, head:4},
    wearable: true,
    encumbrance: 3,
    foreground: 'white',
    mixins: [Game.ItemMixins.Equippable]
};

Game.ShieldTemplate = {
    name: 'shield',
    character: 'θ',
    foreground: 'white',
    armour: {leftLeg: 0, rightLeg: 0, abdomen:4, chest:4, swordArm:0, shieldArm:4, head:0},
    shieldable: true,
    mixins: [Game.ItemMixins.Equippable]
};

Game.TorchTemplate = {
    name: 'torch',
    character: '↨',
    foreground: 'white',
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 2;
        } else {
            return 4;
        }
    },
    wieldable: true,
    shieldable: true,
    additionalLight: 4,
    skillname: 'Club',
    mixins: [Game.ItemMixins.Equippable]
};

Game.TorianMuseliTemplate = {
    name: 'bag of Torian museli',
    character: 'ₐ',
    foreground: 'white',
    usable: true,
    healsMorale: true,
    mixins: [Game.ItemMixins.Useable]
};

Game.TorianHoneyTemplate = {
    name: 'pot of Torian honey',
    character: 'ₑ',
    foreground: 'white',
    usable: true,
    healsMorale: true,
    heals: 'one',
    mixins: [Game.ItemMixins.Useable]
};

Game.TorianMeadTemplate = {
    name: 'small bottle of Torian mead',
    character: 'ₓ',
    foreground: 'white',
    usable: true,
    healsMorale: true,
    heals: 'all',
    mixins: [Game.ItemMixins.Useable]
};

Game.SiblingTemplate = {
        name: 'unconsious body of your sibling',
        character: '∞',
        foreground: 'white',
    };

Game.NullItem = new Game.Item({mixins: [Game.ItemMixins.Equippable]}); // Null item for simplifying logic
Game.FistItem = new Game.Item({    // Fist 'item' for simplifying logic
    name: 'fist',
    damage: function() {
        if (Game.Rules.formUnderlyingSelected() === "2014a") {
            return 1;
        } else {
            return 2;
        }
    },
    skillname: 'Brawl',
    mixins: [Game.ItemMixins.Equippable]
});

Game.SiblingItem = new Game.Item(Game.SiblingTemplate);