//
// © 2014 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//

/* globals Game: true */

Game.Map.Temple = function() {
    var width = Game.getScreenWidth();
    var height = Game.getScreenHeight();
    Game.Map.call(this, this._generateMapTiles(width, height), { isOutside: false });
    
    this.addItem(width-5,height/2,0,Game.SiblingItem);

    this.addEntityAtRandomFloorPosition(new Game.Entity(Game.DemonTemplate),0);
};
Game.Map.Temple.extend(Game.Map);

Game.Map.Temple.prototype._generateMapTiles = function(width, height) {
    var tiles = new Array(width);
    for(var x=0; x<width; x++) {
        tiles[x] = new Array(height);
        for(var y=0; y<height; y++) {
            if (x === 0 || x === width-1 || y === 0 || y === height-1) {
                tiles[x][y] = Game.Tile.wallTile;
            } else {
                tiles[x][y] = Game.Tile.floorTile;
            }
        }
    }
    
    for(x=5; x < height-1; x=x+10) {
        tiles[x][5] = Game.Tile.wallTile;
        tiles[x][height-6] = Game.Tile.wallTile;
    }
    
    tiles[width-5][height/2] = Game.Tile.altarTile;
    tiles[1][height/2] = Game.Tile.templeExitTile;

    return [tiles];
};

Game.Map.Temple.prototype.putAtEntrance = function(entity) {
    entity.setX(1);
    entity.setY(Game.getScreenHeight()/2);
    entity.setZ(0);
    this.addEntity(entity);
};