<?php
/*
Plugin Name: Spider Caves
Plugin URI: https://blog.tremlas.com/wordpress-plugins/spider-cave-plugin-details/
Description: Adds a shortcode that inserts the spider caves game
Version: 3.157.0
Author: David Vines
Author URI: http://tremlas.com
License:  Creative Commons License
*/
/* © Copyright 2014, 2021 David Vines

   Creative Commons License

   This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
*/

include_once 'common.php';

/**
 * Shortcode to add the version of the plugin
 */
function djv_spiderCaves_getSpiderCavesVersion_shortcode() {
	return 'Spider Caves Version 3.157.0';
}
add_shortcode( 'spidercavesVersion', 'djv_spiderCaves_getSpiderCavesVersion_shortcode' );

/**
 * Add the "Spider Caves" game. Only one per page is supported.
 */

// Now for a shortcode that can be used to get links and/or tables for the characters
function djv_spiderCaves_shortcode( $attr, $content = null ) {
	$plugin_url = plugin_dir_url(__FILE__);
	wp_enqueue_script('djv_spidercaves_toggle', $plugin_url.'js/toggle.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_rot', $plugin_url.'js/rot/rot.min.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_sprintf', $plugin_url.'js/sprintf/sprintf.min.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_game', $plugin_url.'js/spidercaves/game.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_screens', $plugin_url.'js/spidercaves/screens.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_glyph', $plugin_url.'js/spidercaves/glyph.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_dynamicglyph', $plugin_url.'js/spidercaves/dynamicglyph.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_tile', $plugin_url.'js/spidercaves/tile.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_builder', $plugin_url.'js/spidercaves/builder.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_map', $plugin_url.'js/spidercaves/map.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_cave', $plugin_url.'js/spidercaves/cave.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_farm', $plugin_url.'js/spidercaves/farm.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_temple', $plugin_url.'js/spidercaves/temple.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_item', $plugin_url.'js/spidercaves/item.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_itemmixins', $plugin_url.'js/spidercaves/itemmixins.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_items', $plugin_url.'js/spidercaves/items.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_rules', $plugin_url.'js/spidercaves/rules.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_entity', $plugin_url.'js/spidercaves/entity.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_entitymixins', $plugin_url.'js/spidercaves/entitymixins.js', array(), '3.157.0' );
	wp_enqueue_script('djv_spidercaves_entities', $plugin_url.'js/spidercaves/entities.js', array(), '3.157.0' );

	wp_enqueue_style('djv_spidercaves_spidercaves', $plugin_url.'css/spidercaves.css', array(), '3.157.0' );

	$text  = '<p>Based on Wayland Games rule set 2014a, but you can modify the rules!</p>' . PHP_EOL;
	$text .= '<form name="underlying">' . PHP_EOL;
    $text .= '    <table>' . PHP_EOL;
	$text .= '        <tr>' . PHP_EOL;
	$text .= '        <td><p>Base rule set:</p></td>' . PHP_EOL;
	$text .= '        <td><select name="underlying"><option>2014a</option><option>2011c</option></select>' . PHP_EOL;
	$text .= '        <td><p><i>Note that this controls the scale used for character attributes' . PHP_EOL;
	$text .= '        and the table used for skill levels based on development points awarded.</i></p></td>' . PHP_EOL;
	$text .= '        </tr>' . PHP_EOL;
	$text .= '        </table>' . PHP_EOL;
	$text .= '        </form>' . PHP_EOL;
	$text .= '        <div onClick="toggle(\'MainTable\')" style="cursor: pointer;"><p><b>[+] More specific options and modifications</b></p></div>' . PHP_EOL;
	$text .= '        <div id="MainTable" style="display: none">' . PHP_EOL;
	$text .= '        <form name="mods">' . PHP_EOL;
	$text .= '        <table>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Body layout:</td>' . PHP_EOL;
	$text .= '        		<td><select name="bodytype"><option>Use Base Rule set</option><option>2014a</option><option>2011c</option></select></td>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Damage:</td>' . PHP_EOL;
	$text .= '        		<td><select name="damage"><option>Use Base Rule set</option><option>2014a</option><option>2011c</option><option>Normal Distribution</option><option>Exponential Distribution</option></select></td>' . PHP_EOL;
	$text .= '        		<td><p><i>Note that use of the named distributions are intended for experimentation with the rule sets!</i></p></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Melee location table:</td>' . PHP_EOL;
	$text .= '        		<td><select name="location"><option>Use Base Rule set</option><option>2014a</option><option>2011c</option></select>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Morale Points:</td>' . PHP_EOL;
	$text .= '        		<td><select name="morale"><option>Use Base Rule set</option><option>2014a</option><option>2011c</option><option>Lower morale</option></select></td>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Adjectives:</td>' . PHP_EOL;
	$text .= '        		<td><select name="adjectives"><option>Use Base Rule set</option><option>Option 2014a</option><option>2011c</option></select>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Extra wounds from major or devastating success:</td>' . PHP_EOL;
	$text .= '        		<td><select name="woundgap"><option>Use Base Rule set</option><option>Option 2014a</option><option>2011c</option></select>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '        		<tr>' . PHP_EOL;
	$text .= '        		<td>Performance:</td>' . PHP_EOL;
	$text .= '        		<td><select name="performance"><option>Use Base Rule set</option><option>Option 2014a</option><option>2011c</option></select>' . PHP_EOL;
	$text .= '        		<td></td>' . PHP_EOL;
	$text .= '        		</tr>' . PHP_EOL;
	$text .= '          </table>' . PHP_EOL;
	$text .= '          </form>' . PHP_EOL;
	$text .= '          </div>' . PHP_EOL;
	$text .= '          <div id="gamecontainer">' . PHP_EOL;
	$text .= '            <div id="roguelike34"></div>' . PHP_EOL;
	$text .= '            <div id="vsep">&nbsp;</div>' . PHP_EOL;
	$text .= '            <div id="charsheet"></div>' . PHP_EOL;
	$text .= '          </div>' . PHP_EOL;
	$text .= '          <div id="hsep">&nbsp;</div>' . PHP_EOL;
	$text .= '          <div id="messages"></div>' . PHP_EOL;

	return $text;
}

add_shortcode( 'spidercaves', 'djv_spiderCaves_shortcode' );

/* --------------------- Functions for updating plugins ------------------------------ */
function djv_spiderCaves_pre_set_site_transient_update_plugins( $transient ) {
 $id = 'spiderCavesPlugin/spiderCavesPlugin.php';
 $name = 'Spider Caves';
 $slug = 'spiderCavesPlugin';
 return djv_plugin_pre_set_site_transient( $transient, $id, $name, $slug );
}
add_filter( 'pre_set_site_transient_update_plugins', 'djv_spiderCaves_pre_set_site_transient_update_plugins' );

function djv_spiderCaves_plugin_info( $result, $action, $args ) {
	$name = 'Spider Caves';
	$slug = 'spiderCavesPlugin';
	if ( 'plugin_information' !== $action ) {
		return $result;
	}
	if ( $slug !== $args->slug) {
		return $result;
	}
	return djv_plugin_get_remote_update_info( $name, $slug );
}
add_filter( 'plugins_api', 'djv_spiderCaves_plugin_info', 10, 3 );

?>